import { FormStore } from '../stores';
import { IMap, IStringMap } from '../types';
import { ComponentClass, FormEvent, StatelessComponent } from 'react';
export interface IOnSubmit {
    (form: IStringMap, ...otherArgs: any[]): any;
}
export interface IWrappedOnSubmit {
    (e: FormEvent<any>, ...otherArgs: any[]): void;
}
export interface IWrappedFormProps {
    form: FormStore;
    onSubmit: IWrappedOnSubmit;
}
export interface IFormOptions<Props> {
    initialValues: IMap | ((props: Props) => IMap) | undefined;
    onSubmit: IOnSubmit;
}
export declare function form<Props>(options: IFormOptions<Props>): (FormComponent: ComponentClass<Props & IWrappedFormProps> | StatelessComponent<Props & IWrappedFormProps>) => ComponentClass<Props>;
